#ifndef AIDGE_CORE_MATCH_RESULT_H_
#define AIDGE_CORE_MATCH_RESULT_H_

#include <memory>
#include <vector>
#include <map>


#include "aidge/graphRegex/matchFsm/FsmRunTimeContext.hpp"
#include "aidge/graph/Node.hpp"

namespace Aidge{

/**
 * @brief class that old the result of a matching
 * give acess to all node ant there tag in the expression
*/
class MatchResult
{
private:
    /* data */
    std::vector<std::shared_ptr<FsmRunTimeContext>> mAllValid;

    /*
    the Run time of eatch sub FSM , to have a valide match we need a set of one run time per FSM compatible
    the id must be contigue
    */
    std::vector<std::vector<std::shared_ptr<FsmRunTimeContext>>> mIdToRunTime;

    std::vector<std::set<NodePtr>> mSolve;

    std::size_t mNbSubStm;

public:
    MatchResult(std::vector<std::shared_ptr<FsmRunTimeContext>> allValid, std::size_t nbSubStm);

    virtual ~MatchResult() = default;

    /**
     * @brief get the set of the node match for une expression
     * @return the set of node of the graph that corresponding to an expression
    */
    std::set<NodePtr> getBiggerSolution(void);

private:

/**
 * @brief recurent function use to inite mSolve in the constructor
 *
 **/

void _generateCombinationd( std::size_t idxSubStm, std::vector<std::shared_ptr<FsmRunTimeContext>>& precedence);

};


}


#endif //AIDGE_CORE_MATCH_RESULT_H_
